;;; Sierra Script 1.0 - (do not remove this comment)
(script# 6)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)

(public
	Eat 0
)

(procedure (Eat food &tmp temp0)
	(= temp0 0)
	(cond 
		((Said '/mushroom,toadstool')
			(cond 
				((and (not (ego has: invMushroom)) (!= curRoomNum 70))
					(HighPrint 6 0)
					;You don't have any.
					)
				((Btst HAVE_KOBOLD_MUSHROOMS)
					(ego use: invMushroom 3)
					(if (Btst HAVE_FAIRY_MUSHROOMS) (HighPrint 6 1))
					;The mushrooms from the Fairy Ring are pretty good, so you hear. 
					;However, when they're mixed with Kobold toadstools...that's a horse of a different color.
					(HighPrint 6 2)
					;You eat some of the Kobold's fungus.
					;Within seconds your insides feel like they're on fire.
					;Guess you're not a Kobold, huh?
					(if (<= [skills skHP] 20)
						(Die
							{Didn't anyone warn you about eating other people's food?__Death by Toadstools doesn't leave mushroom for improvement.}
							#icon 800 1 1
						)
					else
						(ReduceHP 20)
						(HighPrint 6 3)
						;You think that you'd better take it easy for a while until you recover.
					)
					(if (not (ego has: invMushroom)) (Bclr HAVE_KOBOLD_MUSHROOMS))
				)
				(else
					(ego use: invMushroom 3)
					(if (Btst HERO_STARVING) (Bclr HERO_STARVING) else (Bclr HERO_HUNGRY))
					(HighPrint 6 4)
					;You ingest a few of the mushrooms from the Faery Ring.  They taste delicious.
					(HighPrint 6 5)
					;Wow!  Look at all the nice paisley horses!
					(HighPrint 6 6)
					;Not to mention the beautiful neon sky.
					(if (Btst ATE_FAIRY_MUSHROOMS)
						(Die
							6 7
							#title {Where did all the pretty horses go?}
							#icon 800 1 1
							;That's funny.  I could have sworn I warned you about eating too many Magic Mushrooms.
							;Your mind permanently warped, you die a garishly polka-dotted death.
						)
					else
						(HighPrint 6 8)
						;Hmm, that was interesting.  But it would probably not be a good idea to repeat the experience.
					)
					(Bset ATE_FAIRY_MUSHROOMS)
				)
			)
		)
		((Said '/acorn,nut')
			(if (not (ego has: invAcorn))
				(HighPrint 6 0)
				;You don't have any.
			else
				(ego use: invAcorn 1)
				(HighPrint 6 9)
				;You eat the Magic Acorn. It tastes terrible. Better stick to real food next time.
			)
		)
		(mealsPreEaten (food claimed: 1) (HighPrint 6 10))
		((Said '/apple')
			(if (ego has: invApple)
				(ego use: invApple 3)
				(HighPrint 6 11)
				;You eat some of the apples.  They actually taste quite good.
				(= temp0 1)
			else
				(HighPrint 6 12)
				;You don't have any fruit.
			)
		)
		((Said '/carrot')
			(if (ego has: invVegetable)
				(ego use: invVegetable 2)
				(HighPrint 6 13)
				;You eat some vegetables. You think they would have been better saved for cows or horses.
				;Real Heroes eat preserved dry rations.
				(= temp0 1)
			else
				(HighPrint 6 14)
				;You don't have any vegetables.
			)
		)
		((or (Said '/ration,food') (Said 'eat[/!*]'))
			(if (ego has: invRation)
				(ego use: invRation 1)
				(HighPrint 6 15)
				;The rations are tasteless but filling.
				(= temp0 1)
			else
				(HighPrint 6 16)
				;You aren't carrying any rations.
			)
		)
		(else (food claimed: 1) (HighPrint 6 17))
		;Ugh. You don't want to eat *that*.
	)
	(if temp0
		(if (Btst HERO_HUNGRY)
			(Bclr HERO_HUNGRY)
			(Bclr HERO_STARVING)
		else
			(= mealsPreEaten 1)
		)
	)
	(DisposeScript 6)
)
