;;; Sierra Script 1.0 - (do not remove this comment)
(script# 0)
(include system.sh) (include sci2.sh) (include game.sh)
(use GameInit)
(use DrinkItem)
(use EatItem)
(use Sleep)
(use Rest)
(use ThrowFlameDart)
(use ThrowDagger1)
(use ThrowRock)
(use AnimateCalm)
(use AnimateOpen)
(use AnimateDazzle)
(use Interface)
(use n896)
(use StopWalk)
(use Sound)
(use Save)
(use Motion)
(use Game)
(use Inventory)
(use User)
(use Menu)
(use System)

(public
	Glory 0
	Die 1
	SetUpEgo 2
	IsHeapFree 3
	DisposeDialog 4
	LockEgo 5
	UnlockEgo 6
	IsObjectOnControl 7
	GetSongNumber 8
	Bset 9
	Bclr 10
	Btst 11
	IncrementGameDay 12
	Dummy1 13
	StopEgo 14
	PrintNotCloseEnough 15
	PrintAlreadyDoneThat 16
	PrintDontHaveIt 17
	PrintCantDoThat 18
	HighPrint 19
	PrintWarning 20
	PrintTimedMessage 21
	PrintGameTime 22
	CanPickLocks 23
	FaceObject 24
	GiveSilverCoins 25
	SetGameTime 26
	AskQuit 27
	ReduceMP 28
	ReduceSP 29
	TestSkill 30
	UseSkill 31
	AddToScore 32
	;procedure 33 does not exist
	;procedure 34 does not exist
	RollDice 35
	ReduceHP 36
	GetMaxMana 37
	GetMaxStamina 38
	GetMaxHealth 39
	GetMaxWeight 40
	CastSpell 41
	ChangeEgoWalk 42
	EatRation 43
)

(local
	;system-defined global variables
	ego					;pointer to ego (original SSCI name)
	theGame				;ID of the Game instance (original SSCI name)
	curRoom				;ID of current room (original SSCI name)
	gNewSpeed =  6		;CI: used for overRun speed testing.
	quit				;when TRUE, quit game (original SSCI name)
	gCast				;cast	;The ID of a Set of Actors and Egos which constitutes the characters on the screen.
	gRegions			;regions	;The Set of Regions currently in effect.
	gTimers				;timers		;list of timers in the game
	gSounds				;sounds 	;set of sounds being played
	inventory			;set of inventory items in game (not used in Hero's Quest)
	gAddToPics			;addToPics	;list of views added to the picture
	curRoomNum			;current room number
	prevRoomNum			;previous room number
	newRoomNum			;number of room to change to
	debugOn				;generic debug flag -- set from debug menu
	score				;the player's current score
	possibleScore		;highest possible score
	showStyle =  7		;The global style for the transition from one picture to another.  This
     					;may be overridden by the style property of a given room.  See the
     					;DrawPic kernel function for the possible styles.
	overRun				;The number of timer ticks more than the Game's speed which it took to
     					;complete the last animation cycle.  A non-zero overRun means that the
     					;system is not keeping up.
	theCursor			;the number of the current cursor
	normalCursor =  ARROW_CURSOR	;number of normal cursor form
	waitCursor 	=  HAND_CURSOR		;cursor number of "wait" cursor
	userFont 	=  USERFONT			;font to use for Print
	smallFont 	=  4				;small font for save/restore, etc.
	lastEvent						;the last event (used by save/restore game)
	modelessDialog		;the modeless Dialog known to User and Intrface
	bigFont 	=  USERFONT			;large font
	global27 =  12		;CI: unused, unknown purpose
	version =  {ego}	;pointer to 'incver' version string
						;  WARNING!  Must be set in room 0
						;  (usually to {x.yyy    } or {x.yyy.zzz})
	theDoits			;list of objects to get doits each cycle
	curSaveDir			;current save drive/directory string [20 chars long]
	global31			;unused
	global32			;unused
	global33			;unused
	global34			;unused
	global35			;unused
	global36			;unused
	global37			;unused
	global38			;unused
	global39			;unused
	global40			;unused
	global41			;unused
	global42			;unused
	global43			;unused
	global44			;unused
	global45			;unused
	global46			;unused
	global47			;unused
	global48			;unused
	global49			;unused
	animationDelay =  10 ;
	perspective			;player's viewing angle: degrees away
						;  from vertical along y axis
	gFeatures			;features 	;locations that may respond to events
	gSFeatures			;CI: saidFeatures?
	useSortedFeatures	;enable cast & feature sorting? (default is FALSE)
	isDemoGame			;enabled if this is a game demo, and not a full game.??
	egoBlindSpot		;used in 1.200 for SIGHT.SC
	overlays =  -1
	doMotionCue			;a motion cue has occurred - process it
	systemWindow		;ID of standard system window
	global60 =  3		;unused/unknown
	defaultPalette
	modelessPort
	global63			;unused
	global64			;unused
	global65			;unused
	global66			;unused
	global67			;unused
	global68			;unused
	global69			;unused
	global70			;unused
	global71			;unused
	global72			;unused
	global73			;unused
	global74			;unused
	global75			;unused
	global76			;unused
	global77			;unused
	global78			;unused
	global79			;unused
	global80			;unused
	global81			;unused
	global82			;unused
	global83			;unused
	global84			;unused
	global85			;unused
	global86			;unused
	global87			;unused
	global88			;unused
	global89			;unused
	global90			;unused
	global91			;unused
	global92			;unused
	global93			;unused
	global94			;unused
	global95			;unused
	global96			;unused
	global97			;unused
	global98			;unused
	global99			;unused
	
	;game-defined global variables
	egoWalkMode				;0 = walk, 1 = run, 2 = sneak
	razzleDazzleRootBeer	=	TRUE	;debug mode enabled
	global102				;unused
	global103				;unused
	isEgoLocked				
	gGEgoObjX
	gGEgoObjY
	speedCount				;used to test how fast the system is
							;and used in determining detail level. (used in conjunction with detailLevel)
	cSound					;music object, current playing music?
	global109				;unused
	daySheriffBreakIn		;this is the game day that you broke into the Sheriff's house.
							;After this day, the door will be barred, and you can no longer break in.
	dayLOLBreakIn			;this is the game day that you broke into the Little Old Lady's house.
							;After this day, the door willbe barred, and you can no longer break in
	dayCursedByBabaYaga		;this is the game day that Baba Yaga placed her curse on you.  
							;If you don't bring her the mandrake root before the time is up, you will die.
	global113				;?? only referenced outside the sheriff and lol house, when leaving the room.
	countdownAwaitingResponse	;a countdown used by several actors when they are waiting for a response
	gameTimeLastRested		
	gameDayLastRested		
	monsterDistX
	monsterDistY
	global119				;unused
	global120				;unused
	global121				;unused
	global122				;unused
	global123				;unused
	global124				;unused
	global125				;unused
	global126				;unused
	global127				;unused
	global128				;unused
	global129				;unused
	currentTime
	isNightTime
	currentDay
	timeZone				;time of day in game (morning, noon, etc)
	barNote					;EO - Note being passed at the bar
	realTime
	heroType				;The Character Class. 0 = Fighter, 1 = Magic User or 2 = Thief
	detailLevel				;detail level (0 = low, 1 = mid, 2 = high)
	startingRoom
	skills					;hero's skills (25 variable array)
	gIntell
	gAgil
	gVit
	gLuck
	gWeap
	gParry
	gDodge
	global147
	global148
	global149
	global150
	gMagic
	global152
	gHealth
	gStamina
	gEgoMagicSkill
	global156
	global157
	global158
	gGGStrength
	global160
	global161
	global162
	global163	;end of skills
	skillsThreshold			;skillsThreshold (25 variable array) - only used in UseSkill procedure
	global165
	global166
	global167
	global168
	global169
	global170
	global171
	global172
	global173
	global174
	global175
	global176
	global177
	global178
	global179
	global180
	global181
	global182
	global183
	global184
	global185
	global186
	global187
	global188	;end of skillsThreshold
	lockPickBonus	;lock picking bonus (LockPick gives you 10 bonus, Tool Kit gives you 35 bonus)
	;these 8 are part of an array
	spellCost =  2 			;SpellMPUsage (Open)
	global191 =  2 			;SpellMPUsage (Detect Magic)
	global192 =  3 			;SpellMPUsage (Trigger)
	global193 =  3 			;SpellMPUsage (Dazzle)
	global194 =  3 			;SpellMPUsage (Zap)
	global195 =  4 			;SpellMPUsage (Calm)
	global196 =  5 			;SpellMPUsage (Flame Dart)
	global197 =  5 			;SpellMPUsage (Fetch)

	global198				;unused
	global199				;unused
	global200				;unused
	highSpeedHero			;double's ego's walking speed (option removed in 1.200)
	magesMazeButtonIndex
	magesMazeCommand
	global204				;unused
	global205				;unused
	global206				;unused
	global207				;unused
	global208				;unused
	global209				;unused
	global210				;unused
	colourCount
	musicChannels
	spRefreshCountdown =  20
	hpRefreshCountdown =  15
	global215				;unused
	gKeyHandler				;keyDownHandler	;-our EventHandlers, get called by game
	gMouseHandler			;mouseDownHandler ;-our EventHandlers, get called by game
	gDirHandler				;directionHandler	;-our EventHandlers, get called by game
	mealsPreEaten			;As the game progresses through the day, this gets reduced first. If this is 0, then you eat a ration.
	undeadUnguentTimer		;number of game minutes left until the undead unguent wears off
	global221				;unused
	lastViewedSkills		;(25 variable array) - These are the value of skills as last seen on the character sheet. Changed skills will be shown in red.
	global223
	global224
	global225
	global226
	global227
	global228
	global229
	global230
	global231
	global232
	global233
	global234
	global235
	global236
	global237
	global238
	global239
	global240
	global241
	global242
	global243
	global244
	global245
	global246	;end of lastViewedSkills
	global247				;unused
	global248				;unused
	global249				;unused
	zapMeleeBonus			;the extra damage incurred by a zap-charged weapon
	gGStrength				;enemy battle strength??
		
	;array of 9 variables, corresponding to direction event messages
	directionAngle 	=  180	;dirStop (degrees)
	global253 		=  0	;dirN (degrees)
	global254 		=  45	;dirNE (degrees)
	global255 		=  90	;dirE (degrees)
	global256 		=  135	;dirSE (degrees)
	global257 		=  180	;dirS (degrees)
	global258 		=  225	;dirSW (degrees)
	global259 		=  270	;dirW (degrees)
	global260 		=  315	;dirNW (degrees)
	flowersSold				;times sold flowers to the healer
	mushroomsSold			;times sold mushrooms to the healer
	flyingWaterGiven		;has the hero given flying water to the healer?
	brigandHead				;which view to use for the current brigand in combat.
	brigandBattleCount		;how many brigands is the hero fighting at once?
	egoCanFight				;during an arena battle, can the hero fight, or is he in the middle of something?
	dayLastFoughtWeaponMaster =  -1	;when did the hero last fight the weapon master
	daysWithoutSleep		;how many days has the hero gone without sleeping?
	global269				;CI: related to DagNabIt somehow
	thievesGuildPassword
	daggersInRoom			;EO: Daggers thrown on ground
	daggersInMonster		;EO: Daggers thrown in enemy
	roomDaggersDropped		;the last room the hero dropped daggers into. He can pick up all is daggers in this room.
	statColour 		=  vLBLUE	;The colour of stats on the Character Screen
	statColourNew 	=  vLRED	;The colour of stats that have changed since last viewing, on the Character Screen
	roomShieldDropped		;the room hero dropped his shield in. He can pick it up later.
	dayPulledMandrakeRoot =  -3		;dayPulledMandrakeRoot
	dftStatusCode			;default Status Bar refresh code. i.e. Quest for Glory I [%d of 500]
	;wizard Erasmus variables
	global279
	global280
	global281
	
	global282 =  -32768		;Kobold cave-related
	dayKoboldAwakened =  -1	;The day the Kobold was last awakened
	silversOnMonster	;Number of silvers on the monster in the current room
	gKobold
	gCycles
	dayLastFoughtOgre	;the day the Ogre was last fought
	timeZoneLastFoughtOgre	;the time zone the Ogre was last fought
	global289
	fightingKobold	;True if in battle with Kobold?
	global291	;unused
	global292	;unused
	global293	;unused
	global294	;unused
	global295	;unused
	global296	;unused
	global297	;unused
	global298	;unused
	global299	;unused
	global300	;used for DagNabIt
	global301	;unused
	hpStatusView		;the View to use to display battle status
	hpFontColour		;Hit Points Font Colour, during Arena Battles.
	global304	;unused
	global305	;used in Arena (set but never referenced)
	global306			;unused
	global307			;unused
	global308			;unused
	global309			;unused
	global310			;CI: related to Erasmus's Joke telling
	global311			;CI: related to Erasmus's joke telling
	global312			;CI: related to Erasmus's Joke telling
	global313			;CI: related to Erasmus's Joke telling
	saidYesToErasmus	;CI: related to Erasmus's Joke Telling
	koboldStatus
	global316	;EO: unused in 1.200
	global317	;EO: unused in 1.200
	global318	;EO: unused in 1.200
	global319	;EO: unused in 1.200
	global320	;ghosts and graveyard related.
	global321	;EO: unused in 1.200
	global322	;EO: unused in 1.200
	babaYagaHutStatus	;0, 1, 2, 3, 4 as possible values.
	babaYagaStatus		;0, 1, 2, 3, 4 as possible values.
	cSoundDeath =  26
	spireaStatus		;spitting seed related
	global327			;spitting seed related
	global328			;spitting seed related
	applesGiven			;The number of apples given to Frost Giant
	nestCondition		;The state of the next outside the Healer's hut (0 = in tree, 1 = on ground, 2 = burnt)
	numDeadGoblins		;The number of dead goblins in the Goblin Ambush
	monsterInRoom		;EO: Monster in the current room
	gMonsterHealth		;HP of the current fighting monster
	brunoCountdown		;this counts down the game seconds after Bruno has left the target range.  
						;If you don't wait long enough, you'll encounter him
	lastViewedScore		;The game score last viewed on the Character Sheet
	;Bar variables
	drinkOrdered 		;(0 = nothing, 1 = ale, 2 = Troll's sweat, 3 = Dragon's Breath)
	drinkInHand			;(0 = nothing, 1 = ale, 2 = Troll's sweat, 3 = Dragon's Breath)
	numberOfAlesDrunk
	global339	;unused
	;Inn Variables
	foodOrdered			;ordered food... 0 = nothing, 1 = ordered, 2 = at table, 3 = finished
	teaOrdered			;ordered drink... 0 = nothing, 1 = ordered, 2 = at table, 3 = finished
	serveFoodCountdown	;this counts down the cycles after ordering food until it is served.
	;kobold variables
	koboldHP
	global344			;something with kobold
	global345			;something with kobold
	global346			;kobold damage?
	global347			;kobold lightning damage value?
	egoKoboldBattleLoop	;EO: used for 1.200
	global349	;unused
	eventFlags	;Flag start (probably is several globals worth of spots)
	global351
	global352
	global353
	global354
	global355
	global356
	global357
	global358
	global359
	global360
	global361
	global362
	global363
	global364
	global365
	global366
	global367
	global368
	global369
	global370
	global371
	global372
	global373
	global374
	global375
	global376
	global377
	global378
	global379
	global380
	global381
	global382
	global383
	global384
	global385
	global386
	global387
	global388
	global389
	global390
	global391
	global392
	global393
	global394
	global395
	global396
	global397
	global398
	global399
	global400	;end of eventFlags
	userName	;(40 variable array) - name of the user, as supplied by the user when starting a new game.
	global402
	global403
	global404
	global405
	global406
	global407
	global408
	global409
	global410
	global411
	global412
	global413
	global414
	global415
	global416
	global417
	global418
	global419
	global420
	global421
	global422
	global423
	global424
	global425
	global426
	global427
	global428
	global429
	global430
	global431
	global432
	global433
	global434
	global435
	global436
	global437
	global438
	global439
	global440	;end of userName
	invNum		;inventory quantities (start of 42 variable array)
	global442
	global443
	global444
	global445
	global446
	global447
	global448
	global449
	global450
	global451
	global452
	global453
	global454
	global455
	global456
	global457
	global458
	global459
	global460
	global461
	global462
	global463
	global464
	global465
	global466
	global467
	global468
	global469
	global470
	global471
	global472
	global473
	global474
	global475
	global476
	global477
	global478
	global479
	global480
	global481
	global482	;end of Inventory array
	global483			;unused
	global484			;unused
	global485			;unused
	global486			;unused
	global487			;unused
	global488			;unused
	global489			;unused
	global490			;unused
	invDropped			;dropped inventory (start of 42 variable array)
	global492
	global493
	global494
	global495
	global496
	global497
	global498
	global499
	global500
	global501
	global502
	global503
	global504
	global505
	global506
	global507
	global508
	global509
	global510
	global511
	global512
	global513
	global514
	global515
	global516
	global517
	global518
	global519
	global520
	global521
	global522
	global523
	global524
	global525
	global526
	global527
	global528
	global529
	global530
	global531
	global532
	global533	;end of dropped inventory array
	global534			;unused
	global535			;unused
	global536			;unused
	global537			;unused
	global538			;unused
	global539			;unused
	global540			;unused
	invWeight	;inventory weight (start of 41 variable array)
	global542 =  1
	global543 =  1
	global544 =  20
	global545 =  30
	global546 =  15
	global547 =  420
	global548 =  120
	global549 =  1200
	global550 =  720
	global551 =  1
	global552 =  15
	global553 =  30
	global554 =  6
	global555 =  30
	global556 =  180
	global557 =  45
	global558 =  60
	global559 =  30
	global560 =  10
	global561 =  60
	global562 =  30
	global563 =  1
	global564 =  5
	global565 =  30
	global566 =  2
	global567 =  10
	global568 =  3
	global569 =  10
	global570 =  40
	global571 =  10
	global572 =  20
	global573 =  60
	global574 =  2100
	global575 =  40
	global576 =  40
	global577 =  40
	global578 =  40
	global579 =  40
	global580 =  40
	global581 =  30
	global582 =  3
	gOgreX =  160
	gOgreY =  120
	ogreHP =  93
	dayDefeatedOgre =  1000			;day defeated Ogre
	global587						;unused
	global588						;unused
	brutusHP						;HP for Brutus in target range
	dayLastPlayedCribbage =  1000	;day last played Cribbage with Henry
	manaRefreshCountdown =  5		;MP Countdown
	cSoundArena						;music playing in the arenas during a battle
	magesMazePlayCount				;The number of times the hero has played Mage's Maze
	global594						;unused
)
(procedure (Die param1)
	(asm
		pushi    0
		call     LockEgo,  0
		pushi    1
		pushi    100
		callk    Wait,  2
		pushi    #setCursor
		pushi    2
		lsg      normalCursor
		pushi    1
		lag      theGame
		send     8
		pushi    #eachElementDo
		pushi    1
		pushi    132
		lag      gSounds
		send     6
		lag      cSoundDeath
		bnt      code_0fc0
		pushi    #number
		pushi    1
		push    
		pushi    63
		pushi    1
		pushi    15
		pushi    87
		pushi    0
		pushi    42
		pushi    0
		lofsa    music
		send     20
code_0fc0:
		pushi    11
		&rest    param1
		pushi    70
		pushi    250
		pushi    81
		lofsa    {Restore}
		push    
		pushi    1
		pushi    81
		lofsa    { Restart_}
		push    
		pushi    2
		pushi    81
		lofsa    { Quit_}
		push    
		pushi    3
		calle    Print,  22
		push    
		dup     
		ldi      1
		eq?     
		bnt      code_0ff5
		pushi    #restore
		pushi    0
		lag      theGame
		send     4
		jmp      code_1015
code_0ff5:
		dup     
		ldi      2
		eq?     
		bnt      code_1007
		pushi    #restart
		pushi    0
		lag      theGame
		send     4
		jmp      code_1015
code_1007:
		dup     
		ldi      3
		eq?     
		bnt      code_1015
		ldi      1
		sag      quit
		jmp      code_1019
code_1015:
		toss    
		jmp      code_0fc0
code_1019:
		ret     
	)
)

(procedure (SetUpEgo)
	(Animate (gCast elements?) 0)
)

(procedure (IsHeapFree memSize)
	(return (> (MemoryInfo LargestPtr) memSize))
)

(procedure (DisposeDialog)
	(if modelessDialog (modelessDialog dispose:))
)

(procedure (LockEgo)
	(= isEgoLocked TRUE)
	(User canControl: FALSE canInput: FALSE)
	(theGame setCursor: waitCursor TRUE)
	(ego setMotion: 0)
)

(procedure (UnlockEgo)
	(= isEgoLocked FALSE)
	(User canControl: TRUE canInput: TRUE)
	(theGame setCursor: normalCursor (HaveMouse))
)

(procedure (IsObjectOnControl obj event modifiers)
	(return
		(if (MousedOn obj event modifiers)
			(event claimed: TRUE)
			(return TRUE)
		else
			(return FALSE)
		)
	)
)

(procedure (GetSongNumber song)
	(return
		(if (> musicChannels 4)
			(return song)
		else
			(return (+ 100 song))
		)
	)
)

(procedure (Bset bit)
	(= [eventFlags (/ bit 16)]
		(|
			[eventFlags (/ bit 16)]
			(>> $8000 (mod bit 16))
		)
	)
)

(procedure (Bclr bit)
	(= [eventFlags (/ bit 16)]
		(&
			[eventFlags (/ bit 16)]
			(~ (>> $8000 (mod bit 16)))
		)
	)
)

(procedure (Btst bit)
	(return
		(&
			[eventFlags (/ bit 16)]
			(>> $8000 (mod bit 16))
		)
	)
)

(procedure (IncrementGameDay)
	(++ currentDay)
	(Bclr STABLE_CLEAN)
)

(procedure (Dummy1)
)

(procedure (StopEgo)
	(ChangeEgoWalk MOVE_NOCHANGE FALSE)
	(ego
		setPri: -1
		setMotion: 0
		illegalBits: cWHITE
		ignoreHorizon:
		ignoreActors: 0
	)
)

(procedure (PrintNotCloseEnough)
	(HighPrint 0 51)
	;You're not close enough.
)

(procedure (PrintAlreadyDoneThat)
	(HighPrint 0 52)
	;You've already done that.
)

(procedure (PrintDontHaveIt)
	(HighPrint 0 53)
	;You don't have it.
)

(procedure (PrintCantDoThat)
	(HighPrint 0 49)
	;You can't do that now.
)

(procedure (HighPrint &tmp [sizeRect 4] [str 400])
	(DisposeDialog)
	(Format @str &rest)
	(TextSize @[sizeRect 0] @str userFont 0)
	(Print
		@str
		#at	-1 12
		#width (if (> [sizeRect 2] 24) 300 else 0)
		#mode 1
	)
)

(procedure (PrintWarning &tmp [sizeRect 4] [str 400])
	(Format @str &rest)
	(TextSize @[sizeRect 0] @str userFont 0)
	(Print
		@str
		#at -1 115
		#width (if (> [sizeRect 2] 24) 300 else 0)
		#mode 1
	)
)

(procedure (PrintTimedMessage seconds &tmp [sizeRect 4] [str 400])
	(DisposeDialog)
	(Format @str &rest)
	(TextSize @[sizeRect 0] @str userFont 0)
	(Print
		@str
		#at -1 12
		#width (if (> [sizeRect 2] 24) 300 else 0)
		#mode 1
		#dispose
		#time seconds
	)
)

(procedure (PrintGameTime &tmp theCurrentDay [str 30])
	(= theCurrentDay currentDay)
	(if (or (!= timeZone TIME_MIDNIGHT) (> currentTime 500))
		(++ theCurrentDay)
	)
	(HighPrint
		(Format @str
			0 48 ;%s on day %d.
			297 (+ 40 timeZone) ;%s the name of the time of day, from text.297
			theCurrentDay) ; %d the current day
	)
)

(procedure (CanPickLocks)
	(if [skills skLOCKPICKING] (if (ego has: invLockPick) else (ego has: invThiefToolKit)))
)

(procedure (FaceObject who whom)
	(DirLoop
		who
		(GetAngle
			(who x?)
			(who y?)
			(whom x?)
			(whom y?)
		)
	)
	(if (== argc 3)
		(DirLoop
			whom
			(GetAngle
				(whom x?)
				(whom y?)
				(who x?)
				(who y?)
			)
		)
	)
)

(procedure (GiveSilverCoins coins &tmp silver gold)
	(= silver [invNum invSilver])
	(= gold [invNum invGold])
	(if (< (+ silver (* gold 10)) coins)
		(return 0)
	)
	(= silver (- silver coins))
	(while (< silver 0)
		(-- gold)
		(= silver (+ silver 10))
	)
	(= [invNum invSilver] silver)
	(= [invNum invGold] gold)
	(return 1)
)

(procedure (SetGameTime hour minutes &tmp newTimeZone)
	(if (>= argc 1)
		(= currentTime (* 150 hour))
		(= realTime (GetTime 1))
		(if (>= argc 2)
			(= currentTime (+ currentTime (/ (* 150 minutes) 60)))
		)
	)
	(= currentTime (^ currentTime $0001))
	(= newTimeZone timeZone)
	(cond 
		((< currentTime 300) (= timeZone TIME_MIDNIGHT))
		((< currentTime 750) (= timeZone TIME_NOTYETDAWN))
		((< currentTime 1200) (= timeZone TIME_DAWN))
		((< currentTime 1650) (= timeZone TIME_MIDMORNING))
		((< currentTime 2100) (= timeZone TIME_MIDDAY))
		((< currentTime 2550) (= timeZone TIME_MIDAFTERNOON))
		((< currentTime 3000) (= timeZone TIME_SUNSET))
		((< currentTime 3450) (= timeZone TIME_NIGHT))
		(else (= timeZone TIME_MIDNIGHT))
	)
	(if (> timeZone TIME_SUNSET)
		(= isNightTime TRUE)
		(= defaultPalette 1)
	else
		(= isNightTime FALSE)
		(= defaultPalette 0)
	)
	(if (and (== timeZone TIME_MIDNIGHT) (!= newTimeZone TIME_MIDNIGHT))
		(if (== (++ daysWithoutSleep) 1)
			(Print 0 54)
			; You are getting tired.
		else
			(Print 0 55)
			; You are exhausted from lack of sleep.
		)
	)
)

(procedure (AskQuit)
	(= quit
		(Print
			0 64
			#title {Giving up, huh?}
			#button {Quit} 1
			#button {Don't Quit} 0
			#icon 800 1 4
		)
	)
	; How about a slice of quiche?
)

(procedure (ReduceMP amount)
	(if [skills 12]
		(if (< (= [skills skMP] (- [skills skMP] amount)) 0)
			(= [skills skMP] 0)
		)
		(if (> [skills skMP] (GetMaxMana))
			(= [skills skMP] (GetMaxMana))
		)
		(if (> amount 0)
			(UseSkill skINTELLIGENCE (/ amount 5))
			(UseSkill skMAGIC (/ amount 2))
		)
	)
)

(procedure (ReduceSP amount &tmp temp0)
	(if (> amount 0) (UseSkill skVITALITY (/ (+ amount 3) 4)))
	(cond 
		(
		(< (= temp0 (= [skills skSP] (- [skills skSP] amount))) 0)
			(ReduceHP (/ (- -3 [skills skSP]) 4))
			(= [skills skSP] 0)
			(if (not (Btst HERO_NO_STAMINA)) (Bset HERO_NO_STAMINA) (HighPrint 0 56))
			;You are so exhausted that everything you do hurts.  Better get some rest.
			(if (<= [skills skHP] 0)
				(Die 0 57 
					#title {Death from Overwork}
					#icon 800 1 4)
				;That was a little too much for you.  You collapse from exhaustion and die.
				
			)
		)
		((> temp0 4)
			(Bclr HERO_NO_STAMINA)
			(if (> temp0 (GetMaxStamina))
				(= [skills skSP] (GetMaxStamina))
			)
		)
	)
)

(procedure (TestSkill skill threshold bonus &tmp skillValue temp1 temp2 ret)
	(if (not (= skillValue [skills skill])) (return 0))
	(if (== argc 3) (= skillValue (+ skillValue bonus)))
	(if threshold
		(if (>= skill skWEAPONUSE) (ReduceSP (/ threshold 10)))
	else
		(if (>= skill skWEAPONUSE) (ReduceSP (Random 1 6)))
		(= threshold (RollDice))
	)
	(if (>= (UseSkillBonus skLUCK 1) (Random 1 200))
		(= skillValue (+ skillValue (Random 1 20)))
	)
	(= ret (<= threshold skillValue))
	(= temp1
		(cond 
			((<= (= temp1 (Abs (- threshold skillValue))) 10) 2)
			((<= temp1 30) 4)
			((<= temp1 50) 6)
			(else (return ret))
		)
	)
	(= temp2
		(cond 
			((== skill skWEAPONUSE)
				(/ (+ (UseSkillBonus skAGILITY 2) (UseSkillBonus skSTRENGTH 2)) 16))
			(
			(or (== skill skPARRY) (== skill skDODGE) (== skill skSTEALTH))
				(/ (+ (UseSkillBonus skSTRENGTH 3) (UseSkillBonus skINTELLIGENCE 1)) 8))
			((== skill skLOCKPICKING)
				(/ (+ (UseSkillBonus skAGILITY 3) (UseSkillBonus skINTELLIGENCE 1)) 4))
			((or (== skill skTHROWING) (== skill skCLIMBING))
				(/ (+ (UseSkillBonus skAGILITY 3) (UseSkillBonus skSTRENGTH 2)) 5))
			((>= skill skOPEN)
				(/ (+ (UseSkillBonus skMAGIC 4) (UseSkillBonus skINTELLIGENCE 2)) 6))
			(else 10)
		)
	)
	(UseSkill skill (/ temp2 temp1))
	(return ret)
)

(procedure (UseSkill skill skillValue)
	(if (not [skills skill]) (return 0))
	(if
	(> (= skillValue (Abs skillValue)) [skills skill])
		(= skillValue [skills skill])
	)
	(= [skills skEXPERIENCE] (+ [skills skEXPERIENCE] (/ skillValue 4)))
	(if
		(>=
			[skillsThreshold skill]
			[skills (= [skillsThreshold skill]
				(+ [skillsThreshold skill] skillValue)
			)]
		)
		(= [skillsThreshold skill]
			(- [skillsThreshold skill] [skills skill])
		)
		(if
			(>
				(= [skills skill] (+ [skills skill] (Random 1 3)))
				100
			)
			(= [skills skill] 100) ;Stats max out at 100.
		)
		(return 1)
	)
	(return 0)
)

(procedure (AddToScore flag points charClass)
	(if (and (>= argc 3) (!= heroType charClass)) (return))
	(if (not (Btst flag))
		(Bset flag)
		(theGame changeScore: points)
		(UseSkill skINTELLIGENCE points)
	)
)

(procedure (RollDice)
	(return (+ 1 (/ (Random 0 999) 10)))
)

(procedure (ReduceHP amount)
	(if (> amount 0) (UseSkill 3 (/ (+ amount 1) 2)))
	(if (< (= [skills skHP] (- [skills skHP] amount)) 0)
		(= [skills skHP] 0)
	)
	(if (> [skills skHP] (GetMaxHealth))
		(= [skills skHP] (GetMaxHealth))
	)
	(return (> [skills skHP] 0))
)

(procedure (GetMaxMana &tmp magicSkill)
	(return
		(if (= magicSkill [skills skMAGIC])	;If player has any magic skill
			(return (/ (+ [skills skINTELLIGENCE] magicSkill magicSkill) 3))
		else
			(return 0)	;Otherwise, mana will always be at zero
		)
	)
)

(procedure (GetMaxStamina)
	(return (* (+ [skills skAGILITY] [skills skVITALITY]) 2))
)

(procedure (GetMaxHealth &tmp temp0)
	(return
		(+
			(= temp0 (/ (+ [skills skSTRENGTH] [skills skVITALITY] [skills skVITALITY]) 3))
			temp0
		)
	)
)

(procedure (GetMaxWeight)
	(return (+ 40 (/ [skills skSTRENGTH] 2)))
)

(procedure (CastSpell spell &tmp temp0)
	(cond 
		((not [skills skMAGIC])
			(HighPrint 0 58))
			;You don't know how to cast spells.
		((not (ego knows: spell))
			(HighPrint 0 59))
			;You don't know that spell.
		((< [skills skMP] [spellCost (- spell skOPEN)])
			(HighPrint 0 60))
			;You don't have enough Magic Points to cast that spell.
		(else
			(TestSkill spell 0)
			(ReduceMP [spellCost (- spell skOPEN)])
			(return TRUE)
		)
	)
	(return FALSE)
)

(procedure (ChangeEgoWalk walkMode keepMoving &tmp temp0)
	(if keepMoving
		(cond 
			((not (User canControl:))
				(HighPrint 0 49)
				;You can't do that now.
				(return)
			)
			((== egoWalkMode walkMode)
				(HighPrint 0 50)
				;Go ahead. Just do it.
				(return)
			)
		)
	)
	(if (!= walkMode MOVE_NOCHANGE)
		(= egoWalkMode walkMode)
	)
	(ego setLoop: -1 cycleSpeed: 0 moveSpeed: 0)
	(switch egoWalkMode
		(MOVE_RUN
			(ego view: 5 setStep: 6 4 setCycle: egoSW 4)
		)
		(MOVE_SNEAK
			(ego view: 6 setStep: 2 1 setCycle: Walk)
		)
		(else 
			(ego view: 0 setStep: 3 2 setCycle: egoSW 4)
		)
	)
	(if highSpeedHero	;although the option was removed from the menu, the code is still present.
		(ego setStep: (* (ego xStep?) 2) (* (ego yStep?) 2))
	)
	(if (Btst HERO_OVERENCUMBERED) (ego setStep: 1 1))
)

(procedure (EatRation)
	(cond 
		(mealsPreEaten
			(-- mealsPreEaten)
		)
		([invNum invRation]
			(if (not (-- [invNum invRation]))
				(PrintWarning 0 61)
				;You just ate your last ration; you'd better get some more food soon.
			)
		)		
		((Btst HERO_HUNGRY)
			(Bset HERO_STARVING)
			(PrintWarning 0 62)
			;You're starving.  Better find some food *soon*!
			(ReduceHP 1)
		)
		(else (Bset HERO_HUNGRY)
			(PrintWarning 0 63))
			;You're really getting hungry.
	)
)

(procedure (UseSkillBonus skill bonus)
	(UseSkill skill bonus)
	(return (* [skills skill] bonus))
)
;Procedure from HQ1 that was removed from QFG1
;(procedure (ResetDroppedInventory &tmp i temp1)
;	(= i 1)
;	(while (<= i 41)
;		(= [invDropped i] 0)
;		(++ i)
;	)
;)

(class ego of Ego
	;this is a special subclass of Ego to handle the
	;Quest for Glory specific attributes the hero has 
	;i.e. the more complex inventory system, skill management, magic, etc.	
	(properties
		;properties from Feature
		y					 0
		x					 0
		z					 0
		heading 0
		;properties from view
		yStep				 2
		view				 0
		loop				 0
		cel					 0
		priority			 0
		underBits			 0
		signal				 ignoreHorizon
		nsTop				 0
		nsLeft				 0
		nsBottom			 0
		nsRight				 0
		lsTop				 0
		lsLeft				 0
		lsBottom			 0
		lsRight				 0
		brTop				 0
		brLeft				 0
		brBottom			 0
		brRight				 0
		;properties from Prop
		cycleSpeed			 0
		script				 0
		cycler				 0
		timer				 0
		;properties from Actor
		illegalBits 	cWHITE
		xLast				 0
		yLast				 0
		xStep				 3
		moveSpeed			 0
		blocks				 0
		baseSetter			 0
		mover				 0
		looper				 0
		viewer				 0
		avoider				 0
		;properties from Ego
		edgeHit				 0
	)
	
	(method (get item qty &tmp temp0 getAmount currentAmount totalWeight)
		(= getAmount (if (== argc 1) 1 else qty))
		(= currentAmount [invNum item])
		(cond 
			(
				(>
					(= totalWeight
						(+
							(GetTotalWeight)
							(/ (+ 59 (* getAmount [totalWeight item])) 60)
						)
					)
					(GetMaxWeight)
				)
				(if (not (Btst HERO_OVERENCUMBERED))
					(HighPrint 0 0)
					;You are carrying so much that you can hardly move.  You'd better drop something soon.
					(Bset HERO_OVERENCUMBERED)
					(ego setStep: 1 1)
				)
			)
			((Btst HERO_OVERENCUMBERED)
				(Bclr HERO_OVERENCUMBERED)
				(ChangeEgoWalk MOVE_NOCHANGE FALSE))
		)
		(if
		(< (= getAmount (+ getAmount currentAmount)) 0)
			(= getAmount 0)
		)
		(= [invNum item] getAmount)
		(return (- getAmount currentAmount))
	)
	
	(method (put item qty &tmp temp0 putAmount)
		(= putAmount (if (== argc 1) 1 else qty))
		(if (not (= putAmount (self use: item putAmount)))
			(return 0)
		)
		(= [invDropped item]
			(+ [invDropped item] putAmount))
		(return (if (not (ego has: invMushroom)) (Bclr HAVE_FAIRY_MUSHROOMS) else 0))
	)
	
	(method (has item)
		(return [invNum item])
	)
	
	(method (use item qty &tmp temp0 usedQty temp2)
		(if
			(>
				(= usedQty (if (== argc 1) 1 else qty))
				[invNum item]
			)
			(= usedQty [invNum item])
		)
		(self get: item (- usedQty))
		(if (and (== item invMushroom) (not [invNum invMushroom])) (Bclr HAVE_KOBOLD_MUSHROOMS))
		(return usedQty)
	)
	
	(method (drop item)
		(self put: item &rest)
	)
	
	(method (pickUp item qty &tmp temp0 pickUpAmount temp2 droppedAmount n)
		(= pickUpAmount (if (== argc 1) 1 else qty))
		(= droppedAmount [invDropped item])
		(= n 0)
		(if droppedAmount
			(= n
				(if (u< droppedAmount pickUpAmount) droppedAmount else pickUpAmount)
			)
			(self get: item n)
			(= [invDropped item] (- [invDropped item] n))
		)
		(return n)
	)
	
	(method (knows skill)
		(return [skills skill])
	)
	
	(method (learn skill skillLevel &tmp temp0 newSkillLevel)
		(= newSkillLevel (if (== argc 1) 5 else skillLevel))
		(if (and [skills skMAGIC] (> newSkillLevel [skills skill]))
			(= [skills skill] newSkillLevel)
		)
		(return [skills skill])
	)
)

(instance egoBase of Code
	(properties)
	
	(method (doit who &tmp h w)
		(= h (who x?))
		(= w (+ 1 (who y?)))
		(who
			brTop: (- w 2)
			brBottom: w
			brLeft: (- h 9)
			brRight: (+ h 9)
		)
	)
)

(instance egoObj of ego
	(properties)
)

(instance contMusic of Sound
	(properties
		number 26
	)
)

(instance endBattle of Sound
	(properties
		number 26
		priority 10
	)
)

(instance music of Sound
	(properties
		number 26
		priority 10
	)
)

(instance statusCode of Code
	(properties)
	
	(method (doit str)
		(Format str 0 1 score)
		;   Quest for Glory I         [score %d of 500]
	)
)

(instance keyHandler of EventHandler
	(properties)
	
	(method (handleEvent event)
		(if
			(and
				(not (super handleEvent: event))
				(== (event message?) KEY_RETURN)
			)
			(DisposeDialog)
			(event claimed: TRUE)
		)
	)
)

(instance dirHandler of EventHandler
	(properties)
)

(instance mouseHandler of EventHandler
	(properties)
)

(instance hSW of SysWindow
	(properties)
)

(instance Glory of Game
	(properties)
	
	(method (init &tmp theStopWalk)
		(Load rsSCRIPT 1)
		(= systemWindow hSW)
		((= ego egoObj) baseSetter: egoBase)
		(= version {1.200____})
		(= waitCursor 997)
		(StatusLine code: (= dftStatusCode statusCode))
		(= theStopWalk StopWalk)
		(super init:)
		((= gKeyHandler keyHandler) add:)
		((= gMouseHandler mouseHandler) add:)
		((= gDirHandler dirHandler) add:)
		(= musicChannels (DoSound sndCHECK_DRIVER))
		((= cSound contMusic)
			number: (GetSongNumber 26)
			owner: self
			init:
		)
		((= cSoundArena endBattle)
			number: (GetSongNumber 26)
			owner: self
			init:
		)
		(music number: (GetSongNumber 26) owner: self init:)
		(= cSoundDeath (GetSongNumber 26))
		(SetGameInit)
	)
	
	(method (doit &tmp theRealTime)
		(super doit:)
		(if
			;if we've started the game, and time has passed since the last loop,
			;run the regular cycle stuff
			(and
				(Btst PLAYING_GAME)
				(!= realTime (= theRealTime (GetTime SYSTIME1)))
			)
			(= realTime theRealTime)
			(++ currentTime)
			;if it's passed day 7, then time passes twice as fast.
			(if (and (>= currentDay 7) (& currentTime $0001))
				(++ currentTime)
			)
			;if it's passed 3600, change to the next day.
			(if (>= currentTime 3600)
				(= currentTime 0)
				(IncrementGameDay)
			)
			;if ego's cursed, and time is up, time to Die.
			(if
				(and
					(Btst BABAYAGA_CURSE)
					(> currentDay dayCursedByBabaYaga)
					(> currentTime 750)
				)
				(LockEgo)
				(HighPrint 0 2)
				;Suddenly, you hear voices, seeming to come from everywhere at once.  They all sound like Baba Yaga, and they all say:
				;"Wheeeeeere's myyyyyy
				;Maaaandraaaaake Rooooooooooooot????"
				(Die 0 3
					#icon 800 1 2 
					#title {Curses!})
				;Because you failed to meet Baba Yaga's DEADline, her curse turns you into a frog on the spot, and you are forced to live
				;out your years dodging Sauruses (Saurii?) with large feet.
			)
			;if Bruno has just left the target range, count down the seconds until he's out of range.
			(if brunoCountdown (-- brunoCountdown))
			;eat a ration at noon and dinner.
			(if
			(or (== currentTime 1100) (== currentTime 2500))
				(EatRation)
			)
			
			;if ego has used the Undead Unguent, we should decrease it's timer.
			(if (Btst PROTECTED_UNGUENT)
				(switch (-- undeadUnguentTimer)
					(24
						(HighPrint 0 4) ;getting close, so print a warning
						;The tingling sensation is wearing off.
					) 
					
					(0
						(Bclr PROTECTED_UNGUENT)
						(HighPrint 0 5)
						;The tingling sensation is gone.
					)
				)
			)
			
			;every 20 game seconds, ego gets refreshed in Stamina.
			(if (not (-- spRefreshCountdown))
				(= spRefreshCountdown 20)
				(cond 
					;if the hero's starving, or has gone more than 1 day without sleep, reduce SP by 1
					((or (Btst HERO_STARVING) (> daysWithoutSleep 1))
						(ReduceSP 5)
					)
					;if the Hero's running, then reduce SP by 2
					((== egoWalkMode MOVE_RUN)
						(ReduceSP 2)
					)
					;if the hero's not getting hungry, and hasn't gone a day without sleep, then regain by 1
					((and (not (Btst HERO_HUNGRY)) (not daysWithoutSleep))
						(ReduceSP -1)
					)
				)
				;mana gets refreshed once every 5 stamina refreshes
				(if (not (-- manaRefreshCountdown))
					(= manaRefreshCountdown 5)
					(ReduceMP -1)
				)
				;health gets refreshed once every 15 stamina refreshes
				(if (not (-- hpRefreshCountdown))
					(= hpRefreshCountdown 15)
					(ReduceHP -1)
				)
			)
		)
	)
	
	(method (replay)
		(SetGraphicsSoundInit)
		(if (not (OneOf curRoomNum 200 202 203 299 600))
			(TheMenuBar draw:)
			(StatusLine enable:)
		)
		(if (DoSound sndSET_SOUND)
			(SetMenu 774 113 1 110 {Turn off})
		else
			(SetMenu 774 113 0 110 {Turn on})
		)
		(super replay:)
	)
	
	(method (newRoom newRoomNumber)
		(UnlockEgo)
		(super newRoom: newRoomNumber)
		(self
			setCursor: (if isEgoLocked waitCursor else normalCursor) (HaveMouse)
		)
	)
	
	(method (startRoom roomNum &tmp temp0)
		(proc896_0 roomNum) ;Most of the startRoom method was moved into script 896
		(DisposeScript 896)
		(if (u> (MemoryInfo 1) (+ 20 (MemoryInfo 0)))
			(cond 
				(razzleDazzleRootBeer
					(if (Print 0 6 #button {Debug} 1)
						; Memory fragmented.						
						(SetDebug)
					)
				)
				;out of memory problem. quit now by throwing quit/restart/restore dialog.
				((!= roomNum CHARSAVE)
					(Die 0 7
						#title {Bitten by a program bug})
					;Suddenly, the deadly poison Fragmentation Bug leaps out of a crack in the system,
					;and injects you with its poison.  Alas, there is no cure, save to . . .
				)
			)
		)
		(gMouseHandler add: gCast gFeatures)
		StopWalk
		Cycle
		(super startRoom: roomNum)
		(= razzleDazzleRootBeer FALSE)
	)
	
	(method (handleEvent event &tmp temp0 [temp1 4] temp5 temp6)
		(switch (event type?)
			(keyDown
				(gKeyHandler handleEvent: event)
			)
			(mouseDown
				(if
					(and
						(not isEgoLocked)
						(not (gMouseHandler handleEvent: event))
						(not (Random 0 4)) ;1 in 4 chance of displaying a random mouse click message.
						(& (event modifiers?) shiftDown)
					)
					(HighPrint 297 (Random 26 34))
					;random message about random pixels and nothing to see here stuff
				)
			)
			(mouseUp
				(gCast handleEvent: event)
			)
			(direction
				(gDirHandler handleEvent: event)
			)
			(joyDown
				(event type: 4 message: 13)
				(gKeyHandler handleEvent: event)
			)
			(speechEvent
				(cond 
					((super handleEvent: event))
					((or (Said 'quit') (Said 'done,done/game'))
						(AskQuit))
					(
						(or
							(Said 'kiss,boff,blow,crap,leak')
							(Said 'get/crap,leak')
							(Said 'eat/crap')
						)
						(HighPrint 297 (Random 0 8))
						;random message about manners
					)
					((Said 'get>')
						(cond 
							((== (= temp0 (SaidGet event)) NULL)
								(HighPrint 0 8)
								;You can't get that.
							)
							((== temp0 invShield)
								(if (== curRoomNum roomShieldDropped)
									(ego get: invShield)
									(HighPrint 0 9)
									;You retrieve your shield.
									(= roomShieldDropped 0)
								else
									(HighPrint 0 10)
									;There aren't any here.
								)
							)
							(
							(and (== temp0 invDagger) (== curRoomNum roomDaggersDropped))
								(if (and monsterInRoom (> gMonsterHealth 0))
									(HighPrint 0 11)
									;You don't have time -- there's the slight matter of the monster that wants to eat you.
								else
									(= temp6 0)
									(= roomDaggersDropped 0)
									(if (or daggersInRoom [invDropped invDagger])
										(= temp6 1)
										(ego get: invDagger (+ daggersInRoom [invDropped invDagger]))
										(HighPrint 0 12)
										;You pick up the loose daggers.
									)
									(if daggersInMonster
										(= temp6 1)
										(ego get: 7 daggersInMonster)
										(HighPrint 0 13)
										;You retrieve your knives from the dead monster's body, and carefully wipe them clean for reuse.
									)
									(= [invDropped invDagger]
										(= daggersInMonster (= daggersInRoom 0))
									)
									(if (not temp6) (HighPrint 0 10))
								)
							)
							((ego pickUp: temp0 -1)
								(HighPrint 0 14)
								;Ok
							)
							(else
								(HighPrint 0 10)
								;There aren't any here.
							)
						)
					)
					((Said 'throw/dagger') 
						(AnimateThrowingDagger 0)
					)
					((Said 'throw/boulder')
						(AnimateThrowingRock 0)
					)
					((Said 'cast>')
						(cond 
							((not (= temp0 (SaidCast event))) 
								(HighPrint 0 15)
								;That isn't a known spell.
							)
							((CastSpell temp0)
								(switch temp0
									(skOPEN
										(AnimateOpenSpell)
										(HighPrint 0 16)
										;The spell has no effect.
									)
									(skDETECTMAGIC (HighPrint 0 17)
										;You sense no magic in this area.
									)
									(skDAZZLE (AnimateDazzle)
									)
									(skZAP
										(= zapMeleeBonus (+ 5 (/ [skills skZAP] 10)))
										(if (or (ego has: invBroadsword) (ego has: invDagger))
											(HighPrint 0 18)
											;Your weapon is now magically charged.
										else
											(HighPrint 0 19)
											;You don't have a weapon to charge.
										)
									)
									(skCALM (AnimateCalm))
									(skFLAMEDART
										(AnimateThrowingFlameDart 0)
									)
									(else  (HighPrint 0 16)
										;The spell has no effect.
									)
								)
							)
						)
					)
					((Said 'fight')
						(HighPrint 0 20)
						;Aggressive, aren't you?
					)
					((Said 'chat') (HighPrint 0 21)
						;No one responds.
					)
					((or (Said 'put<down>') (Said 'deposit>'))
						(cond 
							((not (= temp0 (SaidGet event)))
								(HighPrint 0 22)
								;I don't know what you're trying to drop.
							)
							([invNum temp0]
								(if (== temp0 invShield)
									(= roomShieldDropped curRoomNum)
									(ego use: invShield)
								else
									(ego drop: temp0 1)
								)
								(HighPrint 0 23)
								;Ok, you drop it.
								(if (not (ego has: invMushroom)) (Bclr HAVE_KOBOLD_MUSHROOMS))
							)
							(else (HighPrint 0 24))
							;You can't drop something you don't have.
						)
					)
					((Said 'walk') 
						(ChangeEgoWalk MOVE_WALK TRUE)
					)
					((Said 'run')
						(ChangeEgoWalk MOVE_RUN TRUE)
					)
					((or (Said '[use]/stealth') (Said 'sneak'))
						(if (!= egoWalkMode MOVE_SNEAK)
							(if (TestSkill skSTEALTH 5 0)
								(ChangeEgoWalk MOVE_SNEAK TRUE)
							else
								(HighPrint 0 25)
								;You're about as stealthy as the average Goon.
							)
						)
					)
					((Said 'unlock,lockpick/door,hasp')
						(HighPrint 0 26)
						;There's no point in trying that here.
					)
					((Said 'lockpick/nose')
						(if (CanPickLocks)
							(HighPrint 0 27)
							;You delicately insert the lockpick into your left nostril.
							(if (not (TestSkill skLOCKPICKING 40))
								(Die 0 28
									#title {The surgeon general warns . . ._}
									#icon 800 0 0
								)
								;Unfortunately, you push it in too far, causing yourself a cerebral hemorrhage.
								;Guess you should have practiced some more on less difficult locks.
							else
								(HighPrint 0 29)
								;Success! You now have an open nose.
							)
						else
							(HighPrint 0 30)
							;You don't have an appropriate tool.
						)
					)
					((Said 'ask')
						(HighPrint 0 31)
						;You get no response.
					)
					((Said 'buy')
						(HighPrint 0 32)
						;It's not for sale.
					)
					((Said 'eat>')
						(Eat event)
					)
					((Said '/ale<root<dazzle<razzle')
						;toggle the debug mode
						(if
						(= razzleDazzleRootBeer (^ razzleDazzleRootBeer $0001))
							(curRoom setLocales: 298)
						)
					)
					((Said 'use,drink>')
						(Drink event 0)
					)
					((Said 'thank')
						(HighPrint 0 33)
						;You're welcome!
					)
					((Said '/sorry')
						(HighPrint 0 34)
						;That's OK.
					)
					((Said 'affirmative,n,please')
						(HighPrint 0 21)
						;No one responds.
					)
					((Said '/hello')
						(HighPrint 0 35)
						;Hi!
					)
					((Said '/bye')
						(HighPrint 0 36)
						;Bye!
					)
					((Said 'open/door')
						(HighPrint 0 37)
						;You're not close enough to a door.
					)
					((Said 'open/box,musicbox')
						(if (ego has: invMusicBox)
							(HighPrint 0 38)
							;You open the music box, which plays Beethoven's "Fur Elise."  After listening to it for a bit, you close the box.
						else
							(HighPrint 0 39)
							;You don't have a box to open.
							
						)
					)
					((Said 'knock')
						(HighPrint 0 40)
						;No one hears you knocking.
					)
					((Said 'sat')
						(HighPrint 0 41)
						;You don't need to.
					)
					((Said 'gave')
						(HighPrint 0 42)
						;You have no reason to do that.
					)
					((Said 'search[/!*,room,area,area]')
						(HighPrint 0 43)
						;You don't find anything interesting.
					)
					((Said 'look,read>')
						(= temp5
							(+
								[invNum (= temp0 (SaidGet event))]
								[invDropped temp0]
							)
						)
						(cond 
							((not temp0) 
								(HighPrint 297 (Random 10 13))
								;you see nothing special, etc.
							)
							(temp5
								(HighPrint 3 (+ temp0 temp0 1))
								;inventory item descriptions
							)
							(else (HighPrint 0 44)
								;You don't see any here.
							)
						)
					)
					((Said 'rest[/!*]')
						(Rest 10 1)
					)
					((or (Said 'nap[/!*]') (Said 'go[<to]/nap'))
						(SleepUntil 5 0)
					)
				)
			)
		)
	)
	
	(method (wordFail word)
		(Printf 0 45 word)
		;You will not need to use the word "%s" in this game.
	)
	
	(method (syntaxFail)
		(HighPrint 0 46)
		;Please try a different way of saying that.
	)
	
	(method (pragmaFail)
		(HighPrint 0 47)
		;I'm not sure what you're trying to do.
	)
)

(instance egoSW of StopWalk
	(properties)
)
