;;; Sierra Script 1.0 - (do not remove this comment)
(script# 334)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use GControl)
(use Extra)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm334 0
)

(local
	thievesAmbush
	thievesSatisfied
)
(procedure (LookAround)
	(HighPrint 334 0)
	;This place seems sinister at night. You see a strangely glowing object at the far end of the alley.
)

(instance frontBarrel of PicView
	(properties
		y 120
		x 119
		view 333
		loop 2
	)
)

(instance backBarrel of PicView
	(properties
		y 97
		x 162
		view 333
		loop 2
	)
)

(instance slink of Actor
	(properties
		y 97
		x 162
		view 333
		loop 3
		illegalBits $0000
	)
)

(instance sneak of Actor
	(properties
		y 120
		x 119
		view 333
		loop 4
		illegalBits $0000
	)
)

(instance knife of Actor
	(properties
		y 1000
		x 1000
		view 333
		priority 10
		illegalBits $0000
	)
)

(instance coin of Extra
	(properties
		y 103
		x 135
		view 333
		cycleType 1
		pauseCel 2
		minPause 12
		minCycles 1
		maxCycles 1
	)
)

(instance rm334 of Room
	(properties
		picture 333
		style $0000
		south 330
	)
	
	(method (init)
		(Load rsVIEW 333)
		(Load rsVIEW 503)
		(super init:)
		(gMouseHandler add: self)
		(StatusLine enable:)
		(self setLocales: 811 801)
		(StopEgo)
		(switch prevRoomNum
			(53
				(ego posn: 160 130 init: setMotion: MoveTo 160 150)
			)
			(else 
				(ego posn: 120 187 init: setMotion: MoveTo 120 180)
			)
		)
		(gAddToPics
			add: frontBarrel backBarrel
			eachElementDo: #init
			doit:
		)
		(slink ignoreActors: 1 setPri: 7 init: stopUpd:)
		(sneak ignoreActors: 1 setPri: 10 init: stopUpd:)
		(knife
			ignoreActors: 1
			setLoop: 5
			setPri: 10
			init:
			stopUpd:
		)
		(coin ignoreActors: 1 setLoop: 6 setPri: 6 init:)
		(if (not (Btst VISITED_ALLEY_NIGHT)) (SetUpEgo) (LookAround))
	)
	
	(method (doit)
		(if (and (not thievesAmbush) (<= (ego y?) 132))
			(= thievesAmbush 1)
			(self setScript: ambushScript)
		)
		(super doit:)
	)
	
	(method (dispose)
		(gMouseHandler delete: self)
		(Bset VISITED_ALLEY_NIGHT)
		(super dispose:)
	)
	
	(method (handleEvent event)
		(super handleEvent: event)
		(cond 
			((Said 'read,look/mark')
				(if (<= (ego y?) 150)
					(HighPrint 334 1)
					;Some sharp object appears to have been thrown at these walls several times.
				else
					(HighPrint 334 2)
					;You can't make them out from here.
				)
			)
			((Said 'look[<at,around][/!*,street,alley]') (LookAround))
			(
			(and (== thievesAmbush 1) (Said 'look/thief,thief,man,man'))
			(HighPrint 334 3)
			;These two men may be smiling at you, but they don't seem very friendly.
			)
			((Said 'look/wall')
				(HighPrint 334 4)
				;The walls seem pretty normal, but there are some curious marks at the north ends of the buildings.
				)
			((Said 'look/barrel')
				(HighPrint 334 5)
				;The barrels are empty, and smell of sour beer.
				)
			(
				(and
					(== thievesAmbush 1)
					(or
						(IsObjectOnControl onDagger event emRIGHT_BUTTON)
						(Said 'look/dagger')
					)
				)
				(HighPrint 334 6)
				;The dagger looks sharp and very deadly.
			)
			(
				(or
					(IsObjectOnControl coin event emRIGHT_BUTTON)
					(Said 'look/alm,item')
				)
				(if (<= (ego y?) 150)
					(HighPrint 334 7)
					;It's a glowing golden coin.
				else
					(HighPrint 334 8)
					;You just see a glint from here.
				)
			)
			(
			(and (== thievesAmbush 1) (IsObjectOnControl sneak event emRIGHT_BUTTON))
			(HighPrint 334 9)
			;He may be short, but the dagger makes him look 7 feet tall.
			)
			(
			(and (== thievesAmbush 1) (IsObjectOnControl slink event emRIGHT_BUTTON))
			(HighPrint 334 10)
			;The florid face tells you that this thief is a regular at the "Aces and Eights" tavern.
			)
			((IsObjectOnControl onBricks event emRIGHT_BUTTON)
				(HighPrint 334 11)
				;The whole place is in need of repair.
				)
			((IsObjectOnControl onFirstBarrel event emRIGHT_BUTTON)
				(HighPrint 334 12)
				;Looks like this barrel once contained Dragon's Breath.  The bottom's eaten out.
				)
			((IsObjectOnControl onSecondBarrel event emRIGHT_BUTTON)
				(HighPrint 334 13)
				;A whiff of Troll's Sweat indicates that this barrel is from the "Aces and Eights" tavern.
				)
			((Said 'get,move,lockpick<up,grab>') (if (Said '/barrel')
					(HighPrint 334 14)
					;The barrels are too heavy to move.
					)
				)
			(
				(and
					(not (if (not thievesAmbush) (<= (ego y?) 132)))
					(Said 'climb')
				)
				(HighPrint 334 15)
				;You're too far away from the back wall.
			)
		)
	)
)

(instance ambushScript of Script
	(properties)
	
	(method (doit)
		(if (not (-- register))
			(HighPrint 334 16)
			;"Aw, now look what ya done.  You made poor Slink run out of patience."
			(LockEgo)
			(self changeState: 7)
		)
		(if
			(and
				thievesAmbush
				(> (ego y?) 143)
				(not thievesSatisfied)
				(not (Btst VISITED_ALLEY_NIGHT))
			)
			(= thievesAmbush 0)
			(= register 0)
			(PrintTimedMessage 4 334 17)
			;"Aw, ya forgot to pay.  What a shame."
			(LockEgo)
			(self changeState: 6)
		)
		(super doit:)
	)
	
	(method (changeState newState)
		(= state newState)
		(switch state
			(0
				(= register 300)
				(LockEgo)
				(slink startUpd: setCycle: EndLoop self)
			)
			(1
				(sneak startUpd: setCycle: EndLoop self)
			)
			(2
				(knife
					startUpd:
					posn: 150 108
					setCycle: Forward
					setMotion: MoveTo 175 95 self
				)
			)
			(3
				(knife setCel: 2 addToPic:)
				(slink ignoreActors: 0 stopUpd:)
				(= cycles 3)
			)
			(4
				(sneak setCel: 3 ignoreActors: 0 stopUpd:)
				(= cycles 5)
			)
			(5
				(cond 
					((not (Btst ALLEY_ROBBED)) (Bset ALLEY_ROBBED)
						(HighPrint 334 32)
						;Slink says, "That coin light spell gets them every time.  See that dagger?  The next one is centered on your back.
						;Give Sneak there your cash and you walk out of here.  It's a simple trade, your life for your money."
						(UnlockEgo))
					((not (Btst LEARNED_THIEF_PASSWORD))
						(HighPrint 334 33)
						;Slink:  "Why, how nice to see you again.  I do hope (for your sake) you brought us some nice shiny new silver."
						(UnlockEgo))
					((not (ego has: invThiefGuildLicense))
						(HighPrint 334 34)
						;Slink:  "Hey, Sneak, this guy's hard of hearing or something.  I told him to get a license last time he was here, and he didn't listen."
						(HighPrint 334 35)
						;"Let's teach him a little lesson about listening to his betters."
						(self changeState: 7)
					)
					((Btst SLINK_WARNING)
						(HighPrint 334 36)
						;As Slink reaches for his dagger, you draw your Thieves' Guild license. . .
						(HighPrint 334 37)
						;You *almost* make it.
						(HighPrint 334 38)
						;Slink:  "Hey, Sneak, this guy's hard of hearing or something.  I told him to stay out of our alley, and he didn't listen."
						(HighPrint 334 35)
						;"Let's teach him a little lesson about listening to his betters."
						(self changeState: 7)
					)
					(else
						(HighPrint 334 36)
						;As Slink reaches for his dagger, you draw your Thieves' Guild license. . .
						(HighPrint 334 39)
						;You win by a close margin.
						(HighPrint 334 40)
						;Slink:  "All right, so you got your license.  How nice.  Guess we don't get to kill you right now."
						(HighPrint 334 41)
						;"But stay out of our alley, 'cause we got real short memories, like."
						(Bset SLINK_WARNING)
						(= thievesSatisfied 1)
						(= register 200)
						(UnlockEgo)
					)
				)
			)
			(6
				(sneak setLoop: 7 cel: 0)
				(self cue:)
			)
			(7
				(= register 0)
				(sneak cycleSpeed: 2 setCycle: EndLoop self)
			)
			(8
				(ego
					view: 503
					setLoop: 0
					cel: 0
					cycleSpeed: 2
					setCycle: EndLoop self
				)
			)
			(9
				(Die 334 42
					#title { Erana missed this spot._}
					#icon 800 0 0)
					;Perhaps you shouldn't explore dark alleys at night unless you are looking for trouble.
					;Or perhaps you should look in your manual to learn how to deal with thieves.
			)
		)
	)
	
	(method (handleEvent event &tmp [temp0 30])
		(switch (event type?)
			(evSAID
				(cond 
					((and (not thievesSatisfied) (Said 'climb'))
						(PrintTimedMessage 3 334 18)
						;That's a pretty tall wall.
						(LockEgo)
						(self changeState: 7)
					)
					((Said 'display,made,gave/sign[<thief]')
						(cond 
							(thievesSatisfied
								(HighPrint 334 19)
								;The thieves seem to be ignoring you.
								)
							((Btst LEARNED_THIEF_PASSWORD)
								(= register 0)
								(HighPrint 334 20)
								;"Yeah, yeah, we know, you're in the Guild too.  How's a poor independent businessman supposed to make a living around here with all this competition?"
								(HighPrint 334 21)
								;"Now go before I forget you made the sign and I make you pay anyway."
								(= thievesSatisfied TRUE)
								(= register 200)
							)
							((not (if [skills skSTEALTH] else [skills skLOCKPICKING]))
								(HighPrint 334 22)
								;"What's that supposed to be?  You trying to pretend you're a thief or something?  Har, har."
								)
							(else
								(= register 0)
								(HighPrint 334 23)
								;"You mean to say that the first customer we've had in months is a fellow thief?
								;And here I thought we were going to make some money."
								(AddToScore POINTS_SHOWTHIEFSIGN 3 CLASS_THIEF)
								(if (not (ego has: invThiefGuildLicense))
									(HighPrint 334 24)
									;"You had better check in at the Thieves' Guild before you get in trouble for practicing without a license.
									;Find Crusher in the tavern, and give him the password."
									(HighPrint
										(Format @temp0 334 25 257 thievesGuildPassword)
										;"The password is '%s'."
									)
								)
								(Bset LEARNED_THIEF_PASSWORD)
								(HighPrint 334 21)
								;"Now go before I forget you made the sign and I make you pay anyway."
								(= thievesSatisfied TRUE)
								(= register 200)
							)
						)
					)
					(
						(or
							(Said 'pay')
							(Said 'gave,put,deposit,throw[/alm,silver,gold]')
						)
						(= register 0)
						(cond 
							(thievesSatisfied
								(HighPrint 334 26)
								;"That's all right; we already have all your money.  But it was certainly nice of you to offer."
								)
							((not (GiveSilverCoins 5))
								(HighPrint 334 27)
								;"Hey!  You don't have enough money to be worth our while.  How do you expect us poor independent businessmen to make a living?"
								(LockEgo) (self changeState: 7))
							(else
								(= [invNum invSilver] 0)
								(= [invNum invGold] 0)
								(HighPrint 334 28)
								;Slink: "Thanks, it's been a pleasure doing business with you.  You can find your way out, I'm sure.
								;But better hurry before my dagger starts to slip."
								(AddToScore POINTS_GETROBBED -10 CLASS_THIEF)
								(= thievesSatisfied TRUE)
								(= register 200)
							)
						)
					)
					((Said 'chat,ask')
						(HighPrint 334 29)
						;Slink:  "My finger is starting to get a bit twitchy, so forget about questions, just pay the man and get out alive."
						)
					(
						(or
							(Said 'fight,kill,attack,capture,chop,beat')
							(Said 'throw/dagger,boulder')
						)
						(HighPrint 334 30)
						;As you start to draw your weapon, the thieves jump you.
						(LockEgo)
						(self changeState: 7)
					)
					((Said 'cast')
						(HighPrint 334 31)
						;Before you can begin to use any magic, the thieves decide that you're up to no good.
						(LockEgo) (self changeState: 7))
				)
			)
		)
		(super handleEvent: event)
	)
)

(instance onFirstBarrel of RFeature
	(properties
		nsTop 120
		nsLeft 111
		nsBottom 142
		nsRight 125
	)
)

(instance onSecondBarrel of RFeature
	(properties
		nsTop 97
		nsLeft 154
		nsBottom 121
		nsRight 171
	)
)
(instance onDagger of RFeature
	(properties
		nsTop 86
		nsLeft 171
		nsBottom 94
		nsRight 179
	)
)

(instance onBricks of RFeature
	(properties
		nsTop 66
		nsLeft 188
		nsBottom 93
		nsRight 201
	)
)
