;;; Sierra Script 1.0 - (do not remove this comment)
(script# 215)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use LoadMany)
(use Inventory)
(use Actor)
(use System)

(public
	closeCombat 0
	aSpell 1
)

(local
	spellCast
	local1
	local2
	haveShield
	local4
	local5 =  2
)
(instance aSpell of Prop
	(properties)
)

(instance closeCombat of Script
	(properties)
	
	(method (init)
		(LoadMany 130 151 152 153 154 155)
		(if (ego has: invShield)
			(Load rsVIEW 540)
		else
			(LoadMany 130 146 147 148 149 150)
			(Load rsVIEW 535)
			(aSpell view: 535)
		)
		(= egoCanFight TRUE)
		(super init: &rest)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(client drawWeapons:)
				(= haveShield ((= local1 (ScriptID 213 0)) egoShield?))
				(= local2 (local1 egoHand?))
				(= local4 (local1 egosBack?))
				(gDirHandler addToFront: client)
				(gMouseHandler addToFront: client)
				(if (and (local1 noWeapon?) (not haveShield))
					(local2 setLoop: 1 setCel: 2)
				)
				(= cycles 1)
			)
			(1
				(if (local1 noWeapon?)
					(self changeState: 3)
				else
					(client
						canFight: 1
						action: 0
						cycleSpeed: 0
						moveSpeed: 0
						view: (local1 weaponView?)
						setLoop: 2
						cel: 0
						stopUpd:
					)
				)
			)
			(2
				(UnlockEgo)
				(self changeState: 1)
			)
			(3
				(Die 215 8
					#title {Bare Hands vs. Teeth and Claws, etc.}
					#icon 516 0 9
					;Caught in combat with neither sword nor dagger, you are unable to resist the monster's fierce onslaught.
					;Try to be better equipped in your next life.
				)
			)
		)
	)
	
	(method (handleEvent pEvent &tmp temp0 temp1 temp2 temp3)
		(if
		(or (not (client canFight?)) (not egoCanFight))
			(pEvent claimed: 1)
			(while ((= temp3 (Event new: 71)) type?)
				(temp3 dispose:)
			)
			(temp3 dispose:)
			(return 1)
		)
		(if script
			(if
				(and
					(== (pEvent type?) evJOYSTICK)
					(!= (pEvent message?) JOY_UP)
				)
				(script cue:)
			else
				(return (pEvent claimed: 1))
			)
		)
		(return
			(switch (pEvent type?)
				(evSAID
					(DisposeDialog)
					(cond 
						((super handleEvent: pEvent))
						((Said 'look')
							(HighPrint 215 0)
							;Quit sightseeing and watch what you're doing!
							)
						((Said 'escape,escape,run')
							(if
								(or
									(== prevRoomNum 14)
									(== prevRoomNum 171)
									(== prevRoomNum 88)
									(== prevRoomNum 89)
									(== prevRoomNum 93)
									(== prevRoomNum 73)
									(== prevRoomNum 91)
								)
								(HighPrint 215 1)
								;You cannot escape this encounter.
							else
								((ScriptID curRoomNum) escaped: 1)
							)
						)
						((Said 'cast>')
							(cond 
								((not (= spellCast (SaidCast pEvent)))
									(HighPrint 215 2)
									;That isn't a known spell.
									)
								(haveShield
									(HighPrint 215 3)
									;You cannot make the arcane gestures to cast spells while carrying your shield.
									)
								(
									(and
										(!= spellCast skFLAMEDART)
										(!= spellCast skZAP)
										(!= spellCast skDAZZLE)
										(!= spellCast skCALM)
									)
									(HighPrint 215 4)
									;This might not be the best time for practicing non-combat spells.
								)
								((CastSpell spellCast)
									(client setEgoMP: [skills skMP])
									(LockEgo)
									(self setScript: (ScriptID 146 0) self spellCast)
								)
							)
						)
						(
							(or
								(Said 'fight,kill,beat,chop')
								(Said 'use/blade,dagger,weapon,shield')
							)
							(HighPrint 215 5)
							;Go ahead!
						)
						((Said 'throw')
							(HighPrint 215 6)
							;You're too close.
							)
						(else
							(HighPrint 215 7)
							;You don't have time for that.
							(pEvent claimed: 1))
					)
				)
				(evMOUSEBUTTON
					(= temp0 (pEvent x?))
					(= temp1 (pEvent y?))
					(pEvent claimed: 1)
				)
				(evJOYSTICK
					(LockEgo)
					(switch (pEvent message?)
						(JOY_UP
							(= local5 2)
							(self setScript: (ScriptID 151 0) self local5)
						)
						(JOY_LEFT
							(= local5 0)
							(self setScript: (ScriptID 154 0) self local5)
						)
						(JOY_RIGHT
							(= local5 1)
							(self setScript: (ScriptID 154 0) self local5)
						)
						(JOY_DOWN
							(= local5 2)
							(cond 
								(haveShield (self setScript: (ScriptID 152 0) self local5))
								((not (ego has: 6)) (self setScript: (ScriptID 153 0) self local5))
								(else
									(= local5 (Random 0 1))
									(self setScript: (ScriptID 154 0) self local5)
								)
							)
						)
					)
					(pEvent claimed: 1)
				)
			)
		)
	)
)
